diff --git a/src/backend/access/nbtree/nbtsearch.c b/src/backend/access/nbtree/nbtsearch.c
index 0605356ec9f..e23657ba275 100644
--- a/src/backend/access/nbtree/nbtsearch.c
+++ b/src/backend/access/nbtree/nbtsearch.c
@@ -1401,7 +1401,7 @@ _bt_first(IndexScanDesc scan, ScanDirection dir)
 		 * opclass input type; this hack simplifies life for ScanKeyInit().
 		 */
 		if (bkey->sk_subtype == rel->rd_opcintype[i] ||
-			bkey->sk_subtype == InvalidOid)
+			!OidIsValid(bkey->sk_subtype))
 		{
 			FmgrInfo   *procinfo;
 
diff --git a/src/backend/access/table/tableamapi.c b/src/backend/access/table/tableamapi.c
index 476663b66aa..86aeea3f9ab 100644
--- a/src/backend/access/table/tableamapi.c
+++ b/src/backend/access/table/tableamapi.c
@@ -120,7 +120,7 @@ check_default_table_access_method(char **newval, void **extra, GucSource source)
 	 * cannot do the catalog access necessary to verify the method.  Must
 	 * accept the value on faith.
 	 */
-	if (IsTransactionState() && MyDatabaseId != InvalidOid)
+	if (IsTransactionState() && OidIsValid(MyDatabaseId))
 	{
 		if (!OidIsValid(get_table_am_oid(*newval, true)))
 		{
diff --git a/src/backend/bootstrap/bootstrap.c b/src/backend/bootstrap/bootstrap.c
index fc8638c1b61..60b168e668c 100644
--- a/src/backend/bootstrap/bootstrap.c
+++ b/src/backend/bootstrap/bootstrap.c
@@ -566,7 +566,7 @@ DefineAttr(char *name, char *type, int attnum, int nullness)
 		attrtypes[attnum]->attcompression = InvalidCompressionMethod;
 		attrtypes[attnum]->attcollation = TypInfo[typeoid].collation;
 		/* if an array type, assume 1-dimensional attribute */
-		if (TypInfo[typeoid].elem != InvalidOid &&
+		if (OidIsValid(TypInfo[typeoid].elem) &&
 			attrtypes[attnum]->attlen < 0)
 			attrtypes[attnum]->attndims = 1;
 		else
diff --git a/src/backend/catalog/aclchk.c b/src/backend/catalog/aclchk.c
index cd139bd65a6..e3a0a544cc3 100644
--- a/src/backend/catalog/aclchk.c
+++ b/src/backend/catalog/aclchk.c
@@ -2972,7 +2972,8 @@ aclcheck_error_type(AclResult aclerr, Oid typeOid)
 {
 	Oid			element_type = get_element_type(typeOid);
 
-	aclcheck_error(aclerr, OBJECT_TYPE, format_type_be(element_type ? element_type : typeOid));
+	aclcheck_error(aclerr, OBJECT_TYPE,
+				   format_type_be(OidIsValid(element_type) ? element_type : typeOid));
 }
 
 
diff --git a/src/backend/catalog/catalog.c b/src/backend/catalog/catalog.c
index 59caae8f1bc..7a4697a4795 100644
--- a/src/backend/catalog/catalog.c
+++ b/src/backend/catalog/catalog.c
@@ -583,7 +583,7 @@ GetNewRelFileNumber(Oid reltablespace, Relation pg_class, char relpersistence)
 	}
 
 	/* This logic should match RelationInitPhysicalAddr */
-	rlocator.locator.spcOid = reltablespace ? reltablespace : MyDatabaseTableSpace;
+	rlocator.locator.spcOid = OidIsValid(reltablespace) ? reltablespace : MyDatabaseTableSpace;
 	rlocator.locator.dbOid =
 		(rlocator.locator.spcOid == GLOBALTABLESPACE_OID) ?
 		InvalidOid : MyDatabaseId;
diff --git a/src/backend/catalog/heap.c b/src/backend/catalog/heap.c
index fd6537567ea..cb16141597c 100644
--- a/src/backend/catalog/heap.c
+++ b/src/backend/catalog/heap.c
@@ -396,7 +396,7 @@ heap_create(const char *relname,
 	 * protected by the existence of a physical file; but for relations with
 	 * no files, add a pg_shdepend entry to account for that.
 	 */
-	if (!create_storage && reltablespace != InvalidOid)
+	if (!create_storage && OidIsValid(reltablespace))
 		recordDependencyOnTablespace(RelationRelationId, relid,
 									 reltablespace);
 
@@ -746,7 +746,7 @@ InsertPgAttributeTuples(Relation pg_attribute_rel,
 		memset(slot[slotCount]->tts_isnull, false,
 			   slot[slotCount]->tts_tupleDescriptor->natts * sizeof(bool));
 
-		if (new_rel_oid != InvalidOid)
+		if (OidIsValid(new_rel_oid))
 			slot[slotCount]->tts_values[Anum_pg_attribute_attrelid - 1] = ObjectIdGetDatum(new_rel_oid);
 		else
 			slot[slotCount]->tts_values[Anum_pg_attribute_attrelid - 1] = ObjectIdGetDatum(attrs->attrelid);
@@ -1024,7 +1024,7 @@ AddNewRelationTuple(Relation pg_class_desc,
 	new_rel_reltup->relispartition = false;
 
 	/* fill rd_att's type ID with something sane even if reltype is zero */
-	new_rel_desc->rd_att->tdtypeid = new_type_oid ? new_type_oid : RECORDOID;
+	new_rel_desc->rd_att->tdtypeid = OidIsValid(new_type_oid) ? new_type_oid : RECORDOID;
 	new_rel_desc->rd_att->tdtypmod = -1;
 
 	/* Now build and insert the tuple */
@@ -1173,7 +1173,7 @@ heap_create_with_catalog(const char *relname,
 	 * by catching it here we can emit a nicer error message.
 	 */
 	existing_relid = get_relname_relid(relname, relnamespace);
-	if (existing_relid != InvalidOid)
+	if (OidIsValid(existing_relid))
 		ereport(ERROR,
 				(errcode(ERRCODE_DUPLICATE_TABLE),
 				 errmsg("relation \"%s\" already exists", relname)));
@@ -1411,7 +1411,7 @@ heap_create_with_catalog(const char *relname,
 	else
 	{
 		/* Caller should not be expecting a type to be created. */
-		Assert(reltypeid == InvalidOid);
+		Assert(!OidIsValid(reltypeid));
 		Assert(typaddress == NULL);
 
 		new_type_oid = InvalidOid;
@@ -1477,7 +1477,7 @@ heap_create_with_catalog(const char *relname,
 		ObjectAddressSet(referenced, NamespaceRelationId, relnamespace);
 		add_exact_object_address(&referenced, addrs);
 
-		if (reloftypeid)
+		if (OidIsValid(reloftypeid))
 		{
 			ObjectAddressSet(referenced, TypeRelationId, reloftypeid);
 			add_exact_object_address(&referenced, addrs);
diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
index 5d9db167e59..120d7ad641c 100644
--- a/src/backend/catalog/index.c
+++ b/src/backend/catalog/index.c
@@ -823,7 +823,7 @@ index_create(Relation heapRelation,
 		Oid			collation = collationIds[i];
 		Oid			opclass = opclassIds[i];
 
-		if (collation)
+		if (OidIsValid(collation))
 		{
 			if ((opclass == TEXT_BTREE_PATTERN_OPS_OID ||
 				 opclass == VARCHAR_BTREE_PATTERN_OPS_OID ||
diff --git a/src/backend/catalog/namespace.c b/src/backend/catalog/namespace.c
index d23474da4fb..696d8f5f5ec 100644
--- a/src/backend/catalog/namespace.c
+++ b/src/backend/catalog/namespace.c
@@ -3891,8 +3891,8 @@ void
 SetTempNamespaceState(Oid tempNamespaceId, Oid tempToastNamespaceId)
 {
 	/* Worker should not have created its own namespaces ... */
-	Assert(myTempNamespace == InvalidOid);
-	Assert(myTempToastNamespace == InvalidOid);
+	Assert(!OidIsValid(myTempNamespace));
+	Assert(!OidIsValid(myTempToastNamespace));
 	Assert(myTempNamespaceSubID == InvalidSubTransactionId);
 
 	/* Assign same namespace OIDs that leader has */
diff --git a/src/backend/catalog/objectaddress.c b/src/backend/catalog/objectaddress.c
index c75b7131ed7..699ac03b676 100644
--- a/src/backend/catalog/objectaddress.c
+++ b/src/backend/catalog/objectaddress.c
@@ -1129,7 +1129,7 @@ get_object_address(ObjectType objtype, Node *object,
 				/* no default, to let compiler warn about missing case */
 		}
 
-		if (!address.classId)
+		if (!OidIsValid(address.classId))
 			elog(ERROR, "unrecognized object type: %d", (int) objtype);
 
 		/*
@@ -2038,7 +2038,7 @@ get_object_address_defacl(List *object, bool missing_ok)
 	if (schema)
 	{
 		schemaid = get_namespace_oid(schema, true);
-		if (schemaid == InvalidOid)
+		if (!OidIsValid(schemaid))
 			goto not_found;
 	}
 	else
diff --git a/src/backend/catalog/partition.c b/src/backend/catalog/partition.c
index 93d72157a46..995f9d8cf22 100644
--- a/src/backend/catalog/partition.c
+++ b/src/backend/catalog/partition.c
@@ -160,7 +160,7 @@ get_partition_ancestors_worker(Relation inhRel, Oid relid, List **ancestors)
 	 * when the partition is being detached.
 	 */
 	parentOid = get_partition_parent_worker(inhRel, relid, &detach_pending);
-	if (parentOid == InvalidOid || detach_pending)
+	if (!OidIsValid(parentOid) || detach_pending)
 		return;
 
 	*ancestors = lappend_oid(*ancestors, parentOid);
diff --git a/src/backend/catalog/pg_aggregate.c b/src/backend/catalog/pg_aggregate.c
index a1cb5719a0c..8717659b874 100644
--- a/src/backend/catalog/pg_aggregate.c
+++ b/src/backend/catalog/pg_aggregate.c
@@ -213,7 +213,7 @@ AggregateCreate(const char *aggName,
 		else
 		{
 			/* special case with VARIADIC last arg */
-			Assert(variadicArgType != InvalidOid);
+			Assert(OidIsValid(variadicArgType));
 			nargs_transfn = 2;
 		}
 		fnArgs[0] = aggTransType;
diff --git a/src/backend/catalog/pg_inherits.c b/src/backend/catalog/pg_inherits.c
index 929bb53b620..c46ad6f61ed 100644
--- a/src/backend/catalog/pg_inherits.c
+++ b/src/backend/catalog/pg_inherits.c
@@ -415,10 +415,10 @@ typeInheritsFrom(Oid subclassTypeId, Oid superclassTypeId)
 
 	/* We need to work with the associated relation OIDs */
 	subclassRelid = typeOrDomainTypeRelid(subclassTypeId);
-	if (subclassRelid == InvalidOid)
+	if (!OidIsValid(subclassRelid))
 		return false;			/* not a complex type or domain over one */
 	superclassRelid = typeidTypeRelid(superclassTypeId);
-	if (superclassRelid == InvalidOid)
+	if (!OidIsValid(superclassRelid))
 		return false;			/* not a complex type */
 
 	/* No point in searching if the superclass has no subclasses */
diff --git a/src/backend/catalog/pg_operator.c b/src/backend/catalog/pg_operator.c
index 44d2ccb6788..2263a428afc 100644
--- a/src/backend/catalog/pg_operator.c
+++ b/src/backend/catalog/pg_operator.c
@@ -239,7 +239,7 @@ OperatorShellMake(const char *operatorName,
 	values[Anum_pg_operator_oprname - 1] = NameGetDatum(&oname);
 	values[Anum_pg_operator_oprnamespace - 1] = ObjectIdGetDatum(operatorNamespace);
 	values[Anum_pg_operator_oprowner - 1] = ObjectIdGetDatum(GetUserId());
-	values[Anum_pg_operator_oprkind - 1] = CharGetDatum(leftTypeId ? 'b' : 'l');
+	values[Anum_pg_operator_oprkind - 1] = CharGetDatum(OidIsValid(leftTypeId) ? 'b' : 'l');
 	values[Anum_pg_operator_oprcanmerge - 1] = BoolGetDatum(false);
 	values[Anum_pg_operator_oprcanhash - 1] = BoolGetDatum(false);
 	values[Anum_pg_operator_oprleft - 1] = ObjectIdGetDatum(leftTypeId);
@@ -462,7 +462,7 @@ OperatorCreate(const char *operatorName,
 	values[Anum_pg_operator_oprname - 1] = NameGetDatum(&oname);
 	values[Anum_pg_operator_oprnamespace - 1] = ObjectIdGetDatum(operatorNamespace);
 	values[Anum_pg_operator_oprowner - 1] = ObjectIdGetDatum(GetUserId());
-	values[Anum_pg_operator_oprkind - 1] = CharGetDatum(leftTypeId ? 'b' : 'l');
+	values[Anum_pg_operator_oprkind - 1] = CharGetDatum(OidIsValid(leftTypeId) ? 'b' : 'l');
 	values[Anum_pg_operator_oprcanmerge - 1] = BoolGetDatum(canMerge);
 	values[Anum_pg_operator_oprcanhash - 1] = BoolGetDatum(canHash);
 	values[Anum_pg_operator_oprleft - 1] = ObjectIdGetDatum(leftTypeId);
@@ -479,7 +479,7 @@ OperatorCreate(const char *operatorName,
 	/*
 	 * If we are replacing an operator shell, update; else insert
 	 */
-	if (operatorObjectId)
+	if (OidIsValid(operatorObjectId))
 	{
 		isUpdate = true;
 
diff --git a/src/backend/catalog/pg_shdepend.c b/src/backend/catalog/pg_shdepend.c
index 16e3e5c7457..2f0f1ace7a3 100644
--- a/src/backend/catalog/pg_shdepend.c
+++ b/src/backend/catalog/pg_shdepend.c
@@ -395,7 +395,7 @@ changeDependencyOnTablespace(Oid classId, Oid objectId, Oid newTablespaceId)
 	sdepRel = table_open(SharedDependRelationId, RowExclusiveLock);
 
 	if (newTablespaceId != DEFAULTTABLESPACE_OID &&
-		newTablespaceId != InvalidOid)
+		OidIsValid(newTablespaceId))
 		shdepChangeDep(sdepRel,
 					   classId, objectId, 0,
 					   TableSpaceRelationId, newTablespaceId,
diff --git a/src/backend/catalog/pg_tablespace.c b/src/backend/catalog/pg_tablespace.c
index 6aca24c231e..3b3fade8c42 100644
--- a/src/backend/catalog/pg_tablespace.c
+++ b/src/backend/catalog/pg_tablespace.c
@@ -39,7 +39,7 @@ get_tablespace_location(Oid tablespaceOid)
 	 * "the database's default tablespace".  So, rather than throwing an error
 	 * for zero, we choose to assume that's what is meant.
 	 */
-	if (tablespaceOid == InvalidOid)
+	if (!OidIsValid(tablespaceOid))
 		tablespaceOid = MyDatabaseTableSpace;
 
 	/*
diff --git a/src/backend/catalog/toasting.c b/src/backend/catalog/toasting.c
index 874a8fc89ad..e42bb2a2082 100644
--- a/src/backend/catalog/toasting.c
+++ b/src/backend/catalog/toasting.c
@@ -265,7 +265,7 @@ create_toast_table(Relation rel, Oid toastOid, Oid toastIndexOid,
 										   true,
 										   OIDOldToast,
 										   NULL);
-	Assert(toast_relid != InvalidOid);
+	Assert(OidIsValid(toast_relid));
 
 	/* make the toast relation visible, else table_open will fail */
 	CommandCounterIncrement();
diff --git a/src/backend/commands/aggregatecmds.c b/src/backend/commands/aggregatecmds.c
index 4268adfe787..97376cecf3e 100644
--- a/src/backend/commands/aggregatecmds.c
+++ b/src/backend/commands/aggregatecmds.c
@@ -320,7 +320,7 @@ DefineAggregate(ParseState *pstate,
 		/* Parameter defaults are not currently allowed by the grammar */
 		Assert(parameterDefaults == NIL);
 		/* There shouldn't have been any OUT parameters, either */
-		Assert(requiredResultType == InvalidOid);
+		Assert(!OidIsValid(requiredResultType));
 	}
 
 	/*
diff --git a/src/backend/commands/cluster.c b/src/backend/commands/cluster.c
index b55221d44cd..d8990930145 100644
--- a/src/backend/commands/cluster.c
+++ b/src/backend/commands/cluster.c
@@ -776,7 +776,7 @@ make_new_heap(Oid OIDOldHeap, Oid NewTableSpace, Oid NewAccessMethod,
 										  true,
 										  OIDOldHeap,
 										  NULL);
-	Assert(OIDNewHeap != InvalidOid);
+	Assert(OidIsValid(OIDNewHeap));
 
 	ReleaseSysCache(tuple);
 
diff --git a/src/backend/commands/copyto.c b/src/backend/commands/copyto.c
index cef452584e5..24caa59e037 100644
--- a/src/backend/commands/copyto.c
+++ b/src/backend/commands/copyto.c
@@ -844,7 +844,7 @@ BeginCopyTo(ParseState *pstate,
 		 * the relation again, we double-check here to make sure it found the
 		 * same one that we have locked.
 		 */
-		if (queryRelId != InvalidOid)
+		if (OidIsValid(queryRelId))
 		{
 			/*
 			 * Note that with RLS involved there may be multiple relations,
diff --git a/src/backend/commands/event_trigger.c b/src/backend/commands/event_trigger.c
index f34868da5ab..31ec353139d 100644
--- a/src/backend/commands/event_trigger.c
+++ b/src/backend/commands/event_trigger.c
@@ -1623,7 +1623,7 @@ pg_event_trigger_table_rewrite_oid(PG_FUNCTION_ARGS)
 	 * Protect this function from being called out of context
 	 */
 	if (!currentEventTriggerState ||
-		currentEventTriggerState->table_rewrite_oid == InvalidOid)
+		!OidIsValid(currentEventTriggerState->table_rewrite_oid))
 		ereport(ERROR,
 				(errcode(ERRCODE_E_R_I_E_EVENT_TRIGGER_PROTOCOL_VIOLATED),
 				 errmsg("%s can only be called in a table_rewrite event trigger function",
diff --git a/src/backend/commands/extension.c b/src/backend/commands/extension.c
index 93ef1ad106f..43a5642fd10 100644
--- a/src/backend/commands/extension.c
+++ b/src/backend/commands/extension.c
@@ -3234,7 +3234,7 @@ AlterExtensionNamespace(const char *extensionName, const char *newschema, Oid *o
 		 * If not all the objects had the same old namespace (ignoring any
 		 * that are not in namespaces or are dependent types), complain.
 		 */
-		if (dep_oldNspOid != InvalidOid && dep_oldNspOid != oldNspOid)
+		if (OidIsValid(dep_oldNspOid) && dep_oldNspOid != oldNspOid)
 			ereport(ERROR,
 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 					 errmsg("extension \"%s\" does not support SET SCHEMA",
diff --git a/src/backend/commands/functioncmds.c b/src/backend/commands/functioncmds.c
index 0335e982b31..e6b1aa9b414 100644
--- a/src/backend/commands/functioncmds.c
+++ b/src/backend/commands/functioncmds.c
@@ -1160,7 +1160,7 @@ CreateFunction(ParseState *pstate, CreateFunctionStmt *stmt)
 			Oid			elt = get_base_element_type(typeid);
 			Oid			transformid;
 
-			typeid = elt ? elt : typeid;
+			typeid = OidIsValid(elt) ? elt : typeid;
 			transformid = get_transform_oid(typeid, languageOid, false);
 			trftypes_list = lappend_oid(trftypes_list, typeid);
 			trfoids_list = lappend_oid(trfoids_list, transformid);
@@ -1188,7 +1188,7 @@ CreateFunction(ParseState *pstate, CreateFunctionStmt *stmt)
 	if (stmt->is_procedure)
 	{
 		Assert(!stmt->returnType);
-		prorettype = requiredResultType ? requiredResultType : VOIDOID;
+		prorettype = OidIsValid(requiredResultType) ? requiredResultType : VOIDOID;
 		returnsSet = false;
 	}
 	else if (stmt->returnType)
diff --git a/src/backend/commands/indexcmds.c b/src/backend/commands/indexcmds.c
index 5712fac3697..9b23db79be6 100644
--- a/src/backend/commands/indexcmds.c
+++ b/src/backend/commands/indexcmds.c
@@ -1049,7 +1049,7 @@ DefineIndex(Oid tableId,
 						else if (exclusion)
 							idx_eqop = indexInfo->ii_ExclusionOps[j];
 
-						if (!idx_eqop)
+						if (!OidIsValid(idx_eqop))
 							ereport(ERROR,
 									errcode(ERRCODE_UNDEFINED_OBJECT),
 									errmsg("could not identify an equality operator for type %s", format_type_be(idx_opcintype)),
@@ -1441,12 +1441,12 @@ DefineIndex(Oid tableId,
 						 * is no such constraint, this index is no good, so
 						 * keep looking.
 						 */
-						if (createdConstraintId != InvalidOid)
+						if (OidIsValid(createdConstraintId))
 						{
 							cldConstrOid =
 								get_relation_idx_constraint_oid(childRelid,
 																cldidxid);
-							if (cldConstrOid == InvalidOid)
+							if (!OidIsValid(cldConstrOid))
 							{
 								index_close(cldidx, lockmode);
 								continue;
@@ -1455,7 +1455,7 @@ DefineIndex(Oid tableId,
 
 						/* Attach index to parent and we're done. */
 						IndexSetParentIndex(cldidx, indexRelationId);
-						if (createdConstraintId != InvalidOid)
+						if (OidIsValid(createdConstraintId))
 							ConstraintSetParentConstraint(cldConstrOid,
 														  createdConstraintId,
 														  childRelid);
@@ -4470,7 +4470,7 @@ IndexSetParentIndex(Relation partitionIdx, Oid parentOid)
 
 	if (!HeapTupleIsValid(tuple))
 	{
-		if (parentOid == InvalidOid)
+		if (!OidIsValid(parentOid))
 		{
 			/*
 			 * No pg_inherits row, and no parent wanted: nothing to do in this
@@ -4488,7 +4488,7 @@ IndexSetParentIndex(Relation partitionIdx, Oid parentOid)
 	{
 		Form_pg_inherits inhForm = (Form_pg_inherits) GETSTRUCT(tuple);
 
-		if (parentOid == InvalidOid)
+		if (!OidIsValid(parentOid))
 		{
 			/*
 			 * There exists a pg_inherits row, which we want to clear; do so.
diff --git a/src/backend/commands/sequence.c b/src/backend/commands/sequence.c
index 8d671b7a29d..9373b118059 100644
--- a/src/backend/commands/sequence.c
+++ b/src/backend/commands/sequence.c
@@ -211,7 +211,7 @@ DefineSequence(ParseState *pstate, CreateSeqStmt *seq)
 
 	address = DefineRelation(stmt, RELKIND_SEQUENCE, seq->ownerId, NULL, NULL);
 	seqoid = address.objectId;
-	Assert(seqoid != InvalidOid);
+	Assert(OidIsValid(seqoid));
 
 	rel = sequence_open(seqoid, AccessExclusiveLock);
 	tupDesc = RelationGetDescr(rel);
@@ -462,7 +462,7 @@ AlterSequence(ParseState *pstate, AlterSeqStmt *stmt)
 									 stmt->missing_ok ? RVR_MISSING_OK : 0,
 									 RangeVarCallbackOwnsRelation,
 									 NULL);
-	if (relid == InvalidOid)
+	if (!OidIsValid(relid))
 	{
 		ereport(NOTICE,
 				(errmsg("relation \"%s\" does not exist, skipping",
diff --git a/src/backend/commands/statscmds.c b/src/backend/commands/statscmds.c
index 77b1a6e2dc5..4fed5e5e99a 100644
--- a/src/backend/commands/statscmds.c
+++ b/src/backend/commands/statscmds.c
@@ -276,7 +276,7 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 
 			/* Disallow data types without a less-than operator */
 			type = lookup_type_cache(attForm->atttypid, TYPECACHE_LT_OPR);
-			if (type->lt_opr == InvalidOid)
+			if (!OidIsValid(type->lt_opr))
 				ereport(ERROR,
 						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 						 errmsg("column \"%s\" cannot be used in statistics because its type %s has no default btree operator class",
@@ -305,7 +305,7 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 
 			/* Disallow data types without a less-than operator */
 			type = lookup_type_cache(var->vartype, TYPECACHE_LT_OPR);
-			if (type->lt_opr == InvalidOid)
+			if (!OidIsValid(type->lt_opr))
 				ereport(ERROR,
 						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 						 errmsg("column \"%s\" cannot be used in statistics because its type %s has no default btree operator class",
@@ -355,7 +355,7 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 			{
 				atttype = exprType(expr);
 				type = lookup_type_cache(atttype, TYPECACHE_LT_OPR);
-				if (type->lt_opr == InvalidOid)
+				if (!OidIsValid(type->lt_opr))
 					ereport(ERROR,
 							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 							 errmsg("expression cannot be used in multivariate statistics because its type %s has no default btree operator class",
diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index 23ebaa3f230..1118a5fc437 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -3692,7 +3692,7 @@ CheckRelationTableSpaceMove(Relation rel, Oid newTableSpaceId)
 	 */
 	oldTableSpaceId = rel->rd_rel->reltablespace;
 	if (newTableSpaceId == oldTableSpaceId ||
-		(newTableSpaceId == MyDatabaseTableSpace && oldTableSpaceId == 0))
+		(newTableSpaceId == MyDatabaseTableSpace && !OidIsValid(oldTableSpaceId)))
 		return false;
 
 	/*
@@ -4050,9 +4050,9 @@ rename_constraint_internal(Oid myrelid,
 	Form_pg_constraint con;
 	ObjectAddress address;
 
-	Assert(!myrelid || !mytypid);
+	Assert(!OidIsValid(myrelid) || !OidIsValid(mytypid));
 
-	if (mytypid)
+	if (OidIsValid(mytypid))
 	{
 		constraintOid = get_domain_constraint_oid(mytypid, oldconname, false);
 	}
@@ -4075,7 +4075,7 @@ rename_constraint_internal(Oid myrelid,
 			 constraintOid);
 	con = (Form_pg_constraint) GETSTRUCT(tuple);
 
-	if (myrelid &&
+	if (OidIsValid(myrelid) &&
 		(con->contype == CONSTRAINT_CHECK ||
 		 con->contype == CONSTRAINT_NOTNULL) &&
 		!con->connoinherit)
@@ -5917,7 +5917,7 @@ ATRewriteTables(AlterTableStmt *parsetree, List **wqueue, LOCKMODE lockmode,
 			 * Select destination tablespace (same as original unless user
 			 * requested a change)
 			 */
-			if (tab->newTableSpace)
+			if (OidIsValid(tab->newTableSpace))
 				NewTableSpace = tab->newTableSpace;
 			else
 				NewTableSpace = OldHeap->rd_rel->reltablespace;
@@ -6018,7 +6018,7 @@ ATRewriteTables(AlterTableStmt *parsetree, List **wqueue, LOCKMODE lockmode,
 			 * If we had SET TABLESPACE but no reason to reconstruct tuples,
 			 * just do a block-by-block copy.
 			 */
-			if (tab->newTableSpace)
+			if (OidIsValid(tab->newTableSpace))
 				ATExecSetTableSpace(tab->relid, tab->newTableSpace, lockmode);
 		}
 
@@ -12090,12 +12090,12 @@ GetForeignKeyActionTriggers(Relation trigrel,
 			continue;
 		if (TRIGGER_FOR_DELETE(trgform->tgtype))
 		{
-			Assert(*deleteTriggerOid == InvalidOid);
+			Assert(!OidIsValid(*deleteTriggerOid));
 			*deleteTriggerOid = trgform->oid;
 		}
 		else if (TRIGGER_FOR_UPDATE(trgform->tgtype))
 		{
-			Assert(*updateTriggerOid == InvalidOid);
+			Assert(!OidIsValid(*updateTriggerOid));
 			*updateTriggerOid = trgform->oid;
 		}
 #ifndef USE_ASSERT_CHECKING
@@ -12151,12 +12151,12 @@ GetForeignKeyCheckTriggers(Relation trigrel,
 			continue;
 		if (TRIGGER_FOR_INSERT(trgform->tgtype))
 		{
-			Assert(*insertTriggerOid == InvalidOid);
+			Assert(!OidIsValid(*insertTriggerOid));
 			*insertTriggerOid = trgform->oid;
 		}
 		else if (TRIGGER_FOR_UPDATE(trgform->tgtype))
 		{
-			Assert(*updateTriggerOid == InvalidOid);
+			Assert(!OidIsValid(*updateTriggerOid));
 			*updateTriggerOid = trgform->oid;
 		}
 #ifndef USE_ASSERT_CHECKING
@@ -17112,7 +17112,7 @@ AlterTableMoveAll(AlterTableMoveAllStmt *stmt)
 		ereport(NOTICE,
 				(errcode(ERRCODE_NO_DATA_FOUND),
 				 errmsg("no matching relations in tablespace \"%s\" found",
-						orig_tablespaceoid == InvalidOid ? "(database default)" :
+						!OidIsValid(orig_tablespaceoid) ? "(database default)" :
 						get_tablespace_name(orig_tablespaceoid))));
 
 	/* Everything is locked, loop through and move all of the relations. */
diff --git a/src/backend/commands/tablespace.c b/src/backend/commands/tablespace.c
index df31eace47a..b328411d70a 100644
--- a/src/backend/commands/tablespace.c
+++ b/src/backend/commands/tablespace.c
@@ -1095,7 +1095,7 @@ check_default_tablespace(char **newval, void **extra, GucSource source)
 	 * cannot do the catalog accesses necessary to verify the name.  Must
 	 * accept the value on faith.
 	 */
-	if (IsTransactionState() && MyDatabaseId != InvalidOid)
+	if (IsTransactionState() && OidIsValid(MyDatabaseId))
 	{
 		if (**newval != '\0' &&
 			!OidIsValid(get_tablespace_oid(*newval, true)))
@@ -1219,7 +1219,7 @@ check_temp_tablespaces(char **newval, void **extra, GucSource source)
 	 * accept the value on faith. Fortunately, there's then also no need to
 	 * pass the data to fd.c.
 	 */
-	if (IsTransactionState() && MyDatabaseId != InvalidOid)
+	if (IsTransactionState() && OidIsValid(MyDatabaseId))
 	{
 		temp_tablespaces_extra *myextra;
 		Oid		   *tblSpcs;
@@ -1249,7 +1249,7 @@ check_temp_tablespaces(char **newval, void **extra, GucSource source)
 			 * nonexistent tablespace, only a NOTICE.  See comments in guc.h.
 			 */
 			curoid = get_tablespace_oid(curname, source <= PGC_S_TEST);
-			if (curoid == InvalidOid)
+			if (!OidIsValid(curoid))
 			{
 				if (source == PGC_S_TEST)
 					ereport(NOTICE,
@@ -1383,7 +1383,7 @@ PrepareTempTablespaces(void)
 
 		/* Else verify that name is a valid tablespace name */
 		curoid = get_tablespace_oid(curname, true);
-		if (curoid == InvalidOid)
+		if (!OidIsValid(curoid))
 		{
 			/* Skip any bad list elements */
 			continue;
diff --git a/src/backend/commands/trigger.c b/src/backend/commands/trigger.c
index 579ac8d76ae..28dab16d239 100644
--- a/src/backend/commands/trigger.c
+++ b/src/backend/commands/trigger.c
@@ -2335,7 +2335,7 @@ ExecCallTriggerFunc(TriggerData *trigdata,
 	 * We cache fmgr lookup info, to avoid making the lookup again on each
 	 * call.
 	 */
-	if (finfo->fn_oid == InvalidOid)
+	if (!OidIsValid(finfo->fn_oid))
 		fmgr_info(trigdata->tg_trigger->tgfoid, finfo);
 
 	Assert(finfo->fn_oid == trigdata->tg_trigger->tgfoid);
diff --git a/src/backend/commands/typecmds.c b/src/backend/commands/typecmds.c
index 5979580139f..341c1b7f574 100644
--- a/src/backend/commands/typecmds.c
+++ b/src/backend/commands/typecmds.c
@@ -529,28 +529,28 @@ DefineType(ParseState *pstate, List *names, List *parameters)
 	 * findTypeInputFunction et al, where they could be shared by AlterType.
 	 */
 #ifdef NOT_USED
-	if (inputOid && !object_ownercheck(ProcedureRelationId, inputOid, GetUserId()))
+	if (OidIsValid(inputOid) && !object_ownercheck(ProcedureRelationId, inputOid, GetUserId()))
 		aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_FUNCTION,
 					   NameListToString(inputName));
-	if (outputOid && !object_ownercheck(ProcedureRelationId, outputOid, GetUserId()))
+	if (OidIsValid(outputOid) && !object_ownercheck(ProcedureRelationId, outputOid, GetUserId()))
 		aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_FUNCTION,
 					   NameListToString(outputName));
-	if (receiveOid && !object_ownercheck(ProcedureRelationId, receiveOid, GetUserId()))
+	if (OidIsValid(receiveOid) && !object_ownercheck(ProcedureRelationId, receiveOid, GetUserId()))
 		aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_FUNCTION,
 					   NameListToString(receiveName));
-	if (sendOid && !object_ownercheck(ProcedureRelationId, sendOid, GetUserId()))
+	if (OidIsValid(sendOid) && !object_ownercheck(ProcedureRelationId, sendOid, GetUserId()))
 		aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_FUNCTION,
 					   NameListToString(sendName));
-	if (typmodinOid && !object_ownercheck(ProcedureRelationId, typmodinOid, GetUserId()))
+	if (OidIsValid(typmodinOid) && !object_ownercheck(ProcedureRelationId, typmodinOid, GetUserId()))
 		aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_FUNCTION,
 					   NameListToString(typmodinName));
-	if (typmodoutOid && !object_ownercheck(ProcedureRelationId, typmodoutOid, GetUserId()))
+	if (OidIsValid(typmodoutOid) && !object_ownercheck(ProcedureRelationId, typmodoutOid, GetUserId()))
 		aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_FUNCTION,
 					   NameListToString(typmodoutName));
-	if (analyzeOid && !object_ownercheck(ProcedureRelationId, analyzeOid, GetUserId()))
+	if (OidIsValid(analyzeOid) && !object_ownercheck(ProcedureRelationId, analyzeOid, GetUserId()))
 		aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_FUNCTION,
 					   NameListToString(analyzeName));
-	if (subscriptOid && !object_ownercheck(ProcedureRelationId, subscriptOid, GetUserId()))
+	if (OidIsValid(subscriptOid) && !object_ownercheck(ProcedureRelationId, subscriptOid, GetUserId()))
 		aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_FUNCTION,
 					   NameListToString(subscriptName));
 #endif
@@ -1592,7 +1592,7 @@ DefineRange(ParseState *pstate, CreateRangeStmt *stmt)
 				   0,			/* Array dimensions of typbasetype */
 				   false,		/* Type NOT NULL */
 				   InvalidOid); /* type's collation (ranges never have one) */
-	Assert(typoid == InvalidOid || typoid == address.objectId);
+	Assert(!OidIsValid(typoid) || typoid == address.objectId);
 	typoid = address.objectId;
 
 	/* Create the multirange that goes with it */
diff --git a/src/backend/commands/vacuum.c b/src/backend/commands/vacuum.c
index e785dd55ce5..27873557c0f 100644
--- a/src/backend/commands/vacuum.c
+++ b/src/backend/commands/vacuum.c
@@ -2320,7 +2320,7 @@ vacuum_rel(Oid relid, RangeVar *relation, VacuumParams params,
 	 * the toaster always uses hardcoded index access and statistics are
 	 * totally unimportant for toast relations.
 	 */
-	if (toast_relid != InvalidOid)
+	if (OidIsValid(toast_relid))
 	{
 		/*
 		 * Force VACOPT_PROCESS_MAIN so vacuum_rel() processes it.  Likewise,
diff --git a/src/backend/commands/view.c b/src/backend/commands/view.c
index 6f0301555e0..f02c80de0fd 100644
--- a/src/backend/commands/view.c
+++ b/src/backend/commands/view.c
@@ -245,7 +245,7 @@ DefineVirtualRelation(RangeVar *relation, List *tlist, bool replace,
 		 */
 		address = DefineRelation(createStmt, RELKIND_VIEW, InvalidOid, NULL,
 								 NULL);
-		Assert(address.objectId != InvalidOid);
+		Assert(OidIsValid(address.objectId));
 
 		/* Make the new view relation visible */
 		CommandCounterIncrement();
diff --git a/src/backend/executor/execUtils.c b/src/backend/executor/execUtils.c
index fdc65c2b42b..9b0ee5427aa 100644
--- a/src/backend/executor/execUtils.c
+++ b/src/backend/executor/execUtils.c
@@ -1495,5 +1495,5 @@ ExecGetResultRelCheckAsUser(ResultRelInfo *relInfo, EState *estate)
 		elog(ERROR, "no RTEPermissionInfo found for result relation with OID %u",
 			 RelationGetRelid(relInfo->ri_RelationDesc));
 
-	return perminfo->checkAsUser ? perminfo->checkAsUser : GetUserId();
+	return OidIsValid(perminfo->checkAsUser) ? perminfo->checkAsUser : GetUserId();
 }
diff --git a/src/backend/executor/functions.c b/src/backend/executor/functions.c
index 630d708d2a3..ae4cc1a8f43 100644
--- a/src/backend/executor/functions.c
+++ b/src/backend/executor/functions.c
@@ -286,7 +286,7 @@ prepare_sql_fn_parse_info(HeapTuple procedureTuple,
 			if (IsPolymorphicType(argtype))
 			{
 				argtype = get_call_expr_argtype(call_expr, argnum);
-				if (argtype == InvalidOid)
+				if (!OidIsValid(argtype))
 					ereport(ERROR,
 							(errcode(ERRCODE_DATATYPE_MISMATCH),
 							 errmsg("could not determine actual type of argument declared %s",
